package uk.co.biogen.sbmonkey;

import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.media.AudioManager;
import android.util.Log;


public class SoundBitesMonkeyWrench
{
  public static void actOnContext(Context appContext, String context)
  {
    Log.d("wrench", "Received the broadcast...");
    
    AudioManager am = (AudioManager) appContext.getSystemService(Context.AUDIO_SERVICE);
    NotificationManager nm = (NotificationManager) appContext.getSystemService(Context.NOTIFICATION_SERVICE);
  
    for(String c : getSilentContexts())
    {
      if(context.equals(c))
      {
        am.setStreamVolume(AudioManager.STREAM_RING,
          am.getStreamMaxVolume(AudioManager.STREAM_RING),
          AudioManager.FLAG_ALLOW_RINGER_MODES|AudioManager.FLAG_PLAY_SOUND);
      } else
      {
        am.setStreamVolume(AudioManager.STREAM_RING,
          0,
          AudioManager.FLAG_ALLOW_RINGER_MODES|AudioManager.FLAG_PLAY_SOUND);
      }
    }
      
    // prepare status bar notification on context changed
    int icon = android.R.drawable.ic_menu_manage;
    CharSequence tickerText = "SoundBites Monkey";
    long when = System.currentTimeMillis();
    CharSequence contentTitle = "SoundBites Monkey";
    CharSequence contentText = "Changed your phone settings for " + context;
    
    Intent notificationIntent = new Intent(appContext, SoundBitesMonkeyWrench.class);
    PendingIntent contentIntent = PendingIntent.getActivity(appContext, 0, notificationIntent, 0);

    Notification notification = new Notification(icon, tickerText, when);
    notification.setLatestEventInfo(appContext, contentTitle, contentText, contentIntent);
    
    nm.notify(2, notification);
  }
  
  private static String[] getSilentContexts()
  {
    return new String[]
    {
      "Speech"
    };
  }
}